// THIS FILE IS GENERATED
// WARNING! All changes made in this file will be lost!

#ifndef __AST_H_INCLUDED
#define __AST_H_INCLUDED

#include <QtCore/QList>
#include <kdev-pg-list.h>

#include <parserexport.h>


#include <QtCore/QString>
#include <kdebug.h>
#include <tokenstream.h>
#include <language/interfaces/iproblem.h>
#include "erlanglexer.h

namespace KDevelop
{
class DUContext;
}


namespace .
{

struct ExpressionAst;
struct InnerStatementListAst;
struct StartAst;
struct StatementAst;
struct TopStatementAst;


struct KDEVERLANGPARSER_EXPORT AstNode
{
    enum AstNodeKind
    {
        ExpressionKind = 1000,
        InnerStatementListKind = 1001,
        StartKind = 1002,
        StatementKind = 1003,
        TopStatementKind = 1004,
        AST_NODE_KIND_COUNT
    };

    int kind;
    qint64 startToken;
    qint64 endToken;

    KDevelop::DUContext* ducontext;

};

struct KDEVERLANGPARSER_EXPORT ExpressionAst: public AstNode
{
    enum { KIND = ExpressionKind };

};

struct KDEVERLANGPARSER_EXPORT InnerStatementListAst: public AstNode
{
    enum { KIND = InnerStatementListKind };

    const KDevPG::ListNode<TopStatementAst *> *statementsSequence;
};

struct KDEVERLANGPARSER_EXPORT StartAst: public AstNode
{
    enum { KIND = StartKind };

    InnerStatementListAst *statements;
};

struct KDEVERLANGPARSER_EXPORT StatementAst: public AstNode
{
    enum { KIND = StatementKind };

    ExpressionAst *expr;
};

struct KDEVERLANGPARSER_EXPORT TopStatementAst: public AstNode
{
    enum { KIND = TopStatementKind };

    StatementAst *statement;
};



} // end of namespace .

#endif

